{ pkgs, nixpkgs, rust-overlay, ... }:
let
  overlays = [ (import rust-overlay) ];
  system = pkgs.stdenv.system;
  rustPkgs = import nixpkgs { inherit system overlays; };
  rustVersion = (rustPkgs.rust-bin.fromRustupToolchainFile ./rust-toolchain.toml);
in {
  packages = with rustPkgs; [
    bacon
    cargo-deny
    just
    (rustVersion.override {
      extensions = [
        "rust-src"
        "rustfmt"
        "clippy"
        "rust-analyzer"
      ];
    })
  ];

  enterTest = ''
    just lint
    just test
    just deny
  '';
}
